<template>
  <div>
    <el-table v-loading="preLoading" :data="preDetailList" style="width: 100%" border :row-style="rowStyle">
      <template v-for="(item, index) in tableHeader1">
        <el-table-column
          v-if="item.columnType == 'id' && executeEval(row,item.expression,true)"
          type="index" :label="item.columnDesc"></el-table-column>
        <el-table-column
          v-if="item.columnType == 'selection'"
          type="selection"
          :width="item.width"
          :selectable="(row,number) => executeFuc(row,'3',item.clickFuc)"
        ></el-table-column>

        <el-table-column
          v-if="item.columnType == 'radio' && executeEval(row,item.expression,true)"
          :prop="item.columnName"
          :label="item.columnDesc"
          :sortable="item.sort"
          :width="item.width"
          :show-overflow-tooltip="item.tooltip"
          :key="item.columnName"
        >
          <template slot-scope="scope">
            <el-radio :label="scope.row.id" v-model="radioCheck"><span></span></el-radio>
          </template>
        </el-table-column>
        <el-table-column
          v-if="item.columnType == 'laber' && executeEval(row,item.expression,true)"
          :prop="item.columnName"
          :label="item.columnDesc"
          :sortable="item.sort"
          :width="item.width"
          :show-overflow-tooltip="item.tooltip"
          :key="item.columnName"
        >
          <template slot-scope="scope">
                <span :style="{color: executeFuc(scope.row,'4',item.lableRuleObj[scope.row[item.columnName]])}">{{
                    item.lableRuleObj[scope.row[item.columnName]]
                  }}</span>
          </template>
        </el-table-column>
        <el-table-column
          v-if="item.columnType == 'eltag' && executeEval(row,item.expression,true)"
          :prop="item.columnName"
          :label="item.columnDesc"
          :sortable="item.sort"
          :width="item.width"
          :show-overflow-tooltip="item.tooltip"
          :key="item.columnName"
        >
          <template slot-scope="scope">
            <el-tag
              :type="executeFuc(scope.row,'4',item,item.lableRuleObj?item.lableRuleObj[scope.row[item.columnName]]:scope.row[item.columnName])">
                  <span>{{
                      item.lableRuleObj ? item.lableRuleObj[scope.row[item.columnName]] : scope.row[item.columnName]
                    }}</span>
            </el-tag>
          </template>
        </el-table-column>
        <el-table-column
          v-if="item.columnType == 'button' && executeEval(row,item.expression,true)"
          :prop="item.columnName"
          :label="item.columnDesc"
          :width="item.width"
          :key="item.columnName"
          fixed="right"
        >
          <template slot-scope="scope">
            <el-button v-for="(buttonItem, buttonIndex) in item.buttonRulObj"
                       :type="buttonItem.type"
                       :size="buttonItem.size"
                       :style="buttonItem.style"
                       :key="buttonItem"
                       v-if="executeEval(scope.row,buttonItem.hasPermi,true)"
                       :disabled="executeEval(scope.row,buttonItem.disabledFuc,false)"
                       @click.native.stop="executeFuc(scope.row,'1',buttonItem.clickFuc)"
            >{{ buttonItem.name }}
            </el-button>
          </template>
        </el-table-column>
        <el-table-column
          v-if="item.columnType == 'text'  && !(item.columnName == 'productDate' || item.columnName == 'expireDate') && executeEval(row,item.expression,true)"
          :prop="item.columnName"
          :label="item.columnDesc"
          :sortable="item.sort"
          :width="item.width"
          :show-overflow-tooltip="item.tooltip"
          :key="item.columnName"
        >
          <template slot-scope="scope">
                <span :style="{color: executeFuc(scope.row,'4',item,scope.row[item.columnName])}">{{
                    scope.row[item.columnName]
                  }}</span>
          </template>
        </el-table-column>
        <el-table-column
          v-if="item.columnType == 'text' && (item.columnName == 'productDate' || item.columnName == 'expireDate') && executeEval(row,item.expression,true)"
          :prop="item.columnName"
          :label="item.columnDesc"
          :sortable="item.sort"
          :width="item.width"
          :show-overflow-tooltip="item.tooltip"
          :key="item.columnName"
        >
          <template slot-scope="scope">
                <span :style="{color: executeFuc(scope.row,'4',item,scope.row[item.columnName])}">{{
                    convertDateFun(scope.row[item.columnName])
                  }}</span>
          </template>
        </el-table-column>
      </template>
    </el-table>
    <pagination
      v-show="preTotal>0"
      :total="preTotal"
      :limit.sync="preQuery.limit"
      :page.sync="preQuery.page"
      @pagination="preHandleCurrentChange"
    ></pagination>


    <el-dialog
      title="扫码替换"
      :visible.sync="codeReplaceVisible"
      :close-on-click-modal="false"
      :close-on-press-escape="false"
      v-if="codeReplaceVisible"
      width="60%"
      append-to-body
    >
      <DialogReplaceCode
        :prescribeData="bizData"
        :closeDialog="closeScanDialog"
      ></DialogReplaceCode>
    </el-dialog>

  </div>
</template>

<script>
import {convertDate} from "@/utils/date";
import {executeFuc, getHead} from "@/utils/customConfig";
import { allDetail, codeRemove, getDetail } from '@/api/collect/collectOrder'
import DialogReplaceCode from "./DialogReplaceCode.vue";

/**
 * 原始处方明细
 */
export default {
  name: "CollectFinishOrderBackupDetail",
  props: {
    prescribeData: {
      type: Object,
      default: null,
      required: true
    },
    //上货方式：1:拆零上货；2:整取上货;
    fifoSplit: {
      type: Object,
      default: null,
      required: true
    },
    dealStatus: {
      type: Number,
      default: 1,
      required: true
    },


  },
  data() {
    return {
      //界面配置相关
      //原始处方明细
      tableHeader1: [],
      queryList1: [],
      tableObj1: [],
      fromList1: [],
      convertDateFun: convertDate,


      preLoading: false,
      preDetailList: [],
      preTotal: 0,
      preQuery: {
        orderIdFk: null,
        page: 1,
        limit: 10,
      },

      countVisible: false,
      codeReplaceVisible: false,
      bizData: null,

    }
  },
  components: {DialogReplaceCode},

  methods: {
    deleteMan(_this, row) {
      _this.$confirm("是否确定删除该条扫码?", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      }).then(() => {
        _this.loading = true;
        _this.codeRemoveMan(row.id, 2);
      })
    },
    deleteCode(_this, row) {
      _this.$confirm("是否确定移除一个条码?", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      }).then(() => {
        _this.loading = true;
        _this.codeRemoveMan(row.id, 1);
      })
    },
    codeRemoveMan(codeManId, delType) {
      let post = {
        codeManId: codeManId,
        delType: delType
      }
      codeRemove(post).then((response) => {
        if (response.code === 20000) {
          this.$message.success("操作成功！");
          this.getList(this)
        } else {
          this.$message.error(response.message);
        }
        this.loading = false;
      }).catch(() => {
        this.loading = false;
      })
    },
    //界面配置-------------end
    executeFuc(row, type, clickFuc, value) {
      return executeFuc(this, row, type, clickFuc, value);
    },
    executeEval(row, expression, defaultRet) {
      if (expression) {
        return eval(expression);
      }
      return defaultRet;
    },
    handleSortChange(column, prop, order) {
      if (column.order === 'descending') {
        this.query.sort = 'desc'
      } else {
        this.query.sort = 'asc'
      }
      this.query.orderBy = column.prop;
      this.getList();
    },
    ///界面配置相关------------end

    preHandleCurrentChange(val) {
      this.filterQuery.page = val.page;
      this.getPrescribeDetail(this, null);
    },
    getPrescribeDetail(_this) {

      if (_this.prescribeData == null)
        return
      if (_this.prescribeData != null) {
        _this.preQuery.page = 1
        _this.preQuery.orderIdFk = this.prescribeData.billNo
      }
      _this.preLoading = true;
      getDetail(_this.preQuery).then(res => {
        _this.preLoading = false
        if (res.code != 20000) {
          _this.$message.error(res.message)
          return
        }
        _this.preDetailList = res.data.list
        _this.preLoading = false
      }).catch(() => {
        _this.preLoading = false
        _this.$message.error("数据加载失败")
      })
    },

    codePlaceClick(_this, row) {
      _this.bizData = row
      _this.codeReplaceVisible = true;
    },

    closeScanDialog() {
      this.getPrescribeDetail(this);
      this.codeReplaceVisible = false;
    },


    rowStyle({row, rowIndex}) {
      let rowBackground = {};
      if (this.$isBlank(row.finishUdiCode)) {
        rowBackground.color = '#f60303';
      }

      rowBackground.height = "38px"
      return rowBackground;
    },

  },
  created() {
    if (this.tableHeader1 == null || this.tableHeader1.length == 0) {
      getHead("FinishOrderDetail", "1").then((re) => {
        // 处理返回的数据
        this.tableObj1 = re.data;
        this.tableHeader1 = re.data.tableList;
        this.queryList1 = re.data.queryList;
        this.fromList1 = re.data.fromList;
        this.getPrescribeDetail(this);
      });
    } else {
      this.getPrescribeDetail(this);
    }

    if (this.dealStatus == 1) {
      this.countVisible = false;
    } else {
      this.countVisible = true;
    }
  }


}
</script>

<style scoped>

</style>
